<?
/***********************************************************/
/* FileBox, used to allows the user to choose colors
/* by Pablo Dall'Oglio 2004-2006
/* revisado by Helder Mauricio Gomes Ferreira 04/2008
/***********************************************************/
class FileBox
{
    /***********************************************************/
    /* Constructor Method
    /***********************************************************/
    function FileBox($Description, $isdir)
    {   //se isdir for verdadeiro  para retornar um diretorio
        //se isdir for falso  para retornar um arquivo de figura 
        global $Pixmaps;
        $tooltip = &new GtkTooltips;
        $this->entry = &new GtkEntry;

        $box = &new GtkHBox;
        $this->widget = new Box($box, $Description);
        $this->button = new Button(array($this, 'FileSel'), _a('File Selection'), $Pixmaps['file'], ICONBUTTON, $isdir, true);
        $this->button->set_relief(GTK_RELIEF_NONE);

        $box->pack_start($this->entry);
        $box->pack_start($this->button);
    }
    /***********************************************************/
    /* Changes the color
    /***********************************************************/
    function set_text($data)
    {
        $this->entry->set_text($data);
    }

    function set_editable($bool)
    {
        $this->entry->set_editable($bool);
    }

    /***********************************************************/
    /* Returns the color
    /***********************************************************/
    function get_text()
    {
        return $this->entry->get_text();
    }

    /***********************************************************/
    /* Changes the visibility
    /***********************************************************/    
    function set_visibility($bool)
    {
        $this->entry->set_visibility($bool);
    }

    /***********************************************************/
    /* Show the button
    /***********************************************************/
    function show()
    {
        $this->widget->show_all();
    }

    /***********************************************************/
    /* Define the size
    /***********************************************************/
    function set_usize($width, $height)
    {
        $this->entry->set_size_request($width, $height);
    }

    /***********************************************************/
    /* File Selection Dialog
    /***********************************************************/
    function FileSel($isdir = false)
    {   //se isdir for verdadeiro  para retornar um diretorio
        //se isdir for falso  para retornar um arquivo de figura 
                                                //$title, $filter = null, $extrabutton = null, $firstdir = null, $Action = null, $Parameter = null, $save='Gtk::FILE_CHOOSER_ACTION_OPEN'
        if($isdir){$isdir= Gtk::FILE_CHOOSER_ACTION_SELECT_FOLDER;
        }else{
        $isdir=Gtk::FILE_CHOOSER_ACTION_OPEN;
        //Gtk::FILE_CHOOSER_ACTION_SAVE    
        }
        $FileSelection = &new FileDialog(_a('File Selection'),$isdir);
        $button_ok = $FileSelection->ok_button;
        $is_file=$FileSelection->resultado[0];
        $is_dir=$FileSelection->resultado[1];
        $is_ok=$FileSelection->resultado[2];
        if($is_ok)
        {
            $this->GetFileName($is_file, $isdir);
        //$button_ok->connect_simple('clicked', array(&$this, 'GetFileName'), &$FileSelection, $is_dir);
        }else{

        $FileSelection = null;
        //$button_cancel->connect_object('clicked', array(&$FileSelection, 'hide'));
        }
    }

    /***********************************************************/
    /* Returns the selected FileName
    /***********************************************************/
    function GetFileName($FileName, $isdir)
    {   
        if ($isdir)
        {
            if (is_dir($FileName))
            {
                //$FileSelection->hide();
                if ((substr($FileName,-1) == '\\') || (substr($FileName,-1) == '/'))
                {
                    $FileName = substr($FileName, 0, -1);
                }
                $this->set_text("$FileName");
            }
        }
        else
        {
            if (file_exists($FileName))
            {
                //$FileSelection->hide();
                if ((substr($FileName,-1) == '\\') || (substr($FileName,-1) == '/'))
                {
                    $FileName = substr($FileName, 0, -1);
                }
                $this->set_text("$FileName");
            }
        }
    }

    /***********************************************************/
    /* KeyTest Method
    /***********************************************************/
    function KeyTest($obj, $window)
    {
        if ($obj->keyval == K_ESC)
        {
            $window->hide();
        }
    }
}
?>
