<?

/***********************************************************/
/* FileSelection class
/* by Pablo Dall'Oglio 2001-2006
/* revisado by Helder Mauricio Gomes Ferreira 04/2008
/* basead partes vindas de kksou
/***********************************************************/
class FileDialog 
{

    public $dialog;
    public $resultado;

    function FileDialog($title,$isdir,$filter = null, $extrabutton = null, $firstdir = null, $Action = null, $Parameter = null, $save='Gtk::FILE_CHOOSER_ACTION_OPEN') 
    {
    //global $dialog;    //__construct ([title], [GtkWindow parent], [action], [buttons], [backend])
    
    if(empty($isdir))
        {
            $isdir=Gtk::FILE_CHOOSER_ACTION_OPEN;
        }
    
    $this->dialog = new GtkFileChooserDialog("File Open", null,$isdir,array(Gtk::STOCK_OK, Gtk::RESPONSE_OK, Gtk::STOCK_CANCEL, Gtk::RESPONSE_CANCEL), null);
    //Gtk::FILE_CHOOSER_ACTION_OPEN	 Indica o modo de abertura. O dilogo de arquivos permitir que o usurio escolha apenas um arquivo.
 	//Gtk::FILE_CHOOSER_ACTION_SAVE	Indica o modo de gravao de arquivo. O usurio permitir que o usurio escolha um arquivo existente, ou digite um novo nome de arquivo.
 	//Gtk::FILE_CHOOSER_ACTION_SELECT_FOLDER	Indica o modo de abertura para seleo de diretrios. O dilogo permitir que o usurio escolha um diretrio existente.
 	//Gtk::FILE_CHOOSER_ACTION_CREATE_FOLDER	Indica o modo para criao de um novo diretrio. O dilogo permitir que o usurio nomeie um diretrio existente ou um novo.
    $hbox = new GtkHBox();
    $this->dialog->vbox->pack_start($hbox, 0, 0);
    $hbox->pack_start(new GtkLabel('File type:'), 0, 0);

    // create a combobox listing the available filter options
    $combobox = &GtkComboBoxEntry::new_text(); // note 1
    $combobox->append_text("All Files");
    $combobox->append_text("Text Files");
    $combobox->append_text("HTML Files");
    $combobox->append_text("PHP Files");
    $combobox->append_text("Image Files");
    $combobox->get_child()->set_text('All Files');
    $combobox->connect('changed', 'on_change_filter'); // note 2
    
    $hbox->pack_start($combobox, 0, 0);

    $this->dialog->show_all();
    $selected_file='';
    $this->resultado=array('','',false);
    
    if ($this->dialog->run() == Gtk::RESPONSE_OK) {
    
    $selected_file=$this->dialog->get_filename();
    $selected_dir=$this->dialog->get_current_folder();//get_uri();
    echo "\n file dialog 42 selected_file = $selected_file\n";
    echo "\n file dialog 43 selected_dir = $selected_dir\n";
    $this->resultado=array($selected_file,$selected_dir,thue);
    if($this->callback)
    {
        //executa a funo programada pelo usuario
        //usuario , passando o caminho do arquivo
        echo "\n abrirpasta callbak $this->callback";
        call_user_func($this->callback,$selected_file);
    }
    $this->dialog->destroy();
    return $selected_file;
    
    }
    
    $this->dialog->destroy();
    
}
    /*
    *metodo setCallBack
    *Define a ao ao selecionar arquivo
    *ou seja, a funo a ser executada
    */
    function setCallBack($callback)
    {
        $this->callback = $callback;
       
    }
function on_change_filter($combobox) {
    $model = $combobox->get_model(); // get the model
    $selected_value = $model->get_value(
        $combobox->get_active_iter(), 0);// note 3
    echo "selected_value = $selected_value\n";
    $filter = new GtkFileFilter(); // note 4
    switch($selected_value) { // note 5
        case 'All Files':
            $filter->add_pattern("*"); // note 5
            break;
        case 'Text Files':
            $filter->add_pattern("*.txt"); // note 5
            break;
        case 'HTML Files':
            $filter->add_mime_type("text/html"); // note 5
            break;
        case 'PHP Files':
            $filter->add_pattern("*.php"); // note 5
            break;
        case 'Image Files';
            $filter->add_pixbuf_formats(); // note 5
            break;
    }

   
    $this->dialog->set_filter($filter); // note 6

}
    /***********************************************************/
    /* PopUp the Drives menu
    /***********************************************************/
    function PopDrives()
    {
        $this->MenuDrives->popup(null, null, null, 1, 1);
    }

    /***********************************************************/
    /* Returns the FileName
    /***********************************************************/
    function get_filenames()
    {
        $dir = $this->DirListing;
        $EntryPath = $this->EntryPath;
        $file = $EntryPath->get_text();

        if (substr($file,0,1)== bar)
            return $file;

        if (substr($dir->Directory, -1) != bar)
            return $dir->Directory . bar . $file;
        else
            return $dir->Directory . $file;
    }

    /***********************************************************/
    /* Returns the selected path
    /***********************************************************/
    function get_path()
    {
        $dir = $this->DirListing;

        if ($dir)
        {
            return $dir->Directory;
        }
    }

    /***********************************************************/
    /* Hide the window
    /***********************************************************/
    function hide()
    {
        $this->window->hide();
    }

    /***********************************************************/
    /* Key Test Method
    /***********************************************************/
    function KeyTest($obj, $context)
    {
        if ($context == 'window')
        {
            if ($obj->keyval == K_ESC)
            {
                $this->hide();
            }
        }
        else if ($context == 'combo')
        {
            if ($obj->keyval == K_ENTER)
            {
                $this->ComboChange();
            }
        }
        else if ($context == 'entry')
        {
            if ($obj->keyval == K_ENTER)
            {
                $mypath = $this->get_filename();
                if (is_dir($mypath))
                {
                    $this->GoDir($mypath);
                }
                else // (is_file($mypath))
                {
                    $bt = $this->ok_button;
                    $bt->clicked();
                }
            }
        }
    }

    /***********************************************************/
    /* Changes the directory on Combo command
    /***********************************************************/
    function ComboChange()
    {
        $entry = $this->ComboPath->entry;
        $Directory = $entry->get_text();
        if (is_dir($Directory))
        {
            $this->GoDir($Directory);
        }
    }

    /***********************************************************/
    /* Goes up
    /***********************************************************/
    function GoUp()
    {
        $dir = $this->DirListing;
        $Directory = $dir->Directory;
        $split = explode($this->barra,$Directory);
        $up = $this->root;
        for ($n=1; $n < count($split) -1; $n++)
        {
            if ($n == 1)
                $up .= $split[$n];
            else
                $up .= $this->barra . $split[$n];
        }
        $this->GoDir($up);
    }

    /***********************************************************/
    /* Reloads the directory listing
    /***********************************************************/
    function Reload()
    {
        $dir = $this->DirListing;
        $dir->LoadDirectory($dir->Directory);
    }

    /***********************************************************/
    /* Ask by a new folder
    /***********************************************************/
    function NewFolder()
    {
        $this->InputBox = new InputBox(_a('New Folder'), 180, '', array(&$this,'MakeFolder'));
    }

    /***********************************************************/
    /* Creates a new folder
    /***********************************************************/
    function MakeFolder($entry)
    {
        $dir = $this->DirListing;
        $Directory = $dir->Directory;
        $InputBox = $this->InputBox;
        $Item = $entry->get_chars(0, -1);
        $Caminho =  $Directory . $this->barra . $Item;

        if (@mkdir($Caminho))
        {
            $this->Reload();
        }
        else
        {
            new Dialog(_a('Cannot create the directory'));
        }
    }

    /***********************************************************/
    /* Changes the directory
    /***********************************************************/
    function GoDir($Directory)
    {
        $dir = &$this->DirListing;
        $dir->LoadDirectory($Directory);
        $entry = $this->EntryPath;
        $entry->set_text('');
        $this->window->set_focus($entry);
    }
}

/***********************************************************/
/* DirListing class a GtkCList for directory listing
/* by Pablo Dall'Oglio 2004-2006
/* esta class no foi revisada para php-gtk2
/***********************************************************/
class DirListing extends GtkCList
{
    /***********************************************************/
    /* Constructor Method
    /***********************************************************/
    function DirListing($gdkwindow, $array)
    {
        parent::__construct(count($array), $array);
        parent::connect_simple('select-row', array(&$this, 'GoDir'));
    }

    /***********************************************************/
    /* Changes the directory
    /***********************************************************/
    function GoDir()
    {
        $selection = $this->selection;
        $line = $selection[0];
        $dir = $this->get_pixtext($line,0);
        if (substr($this->Directory, -1) != $this->barra)
            $Directory = $this->Directory . $this->barra . $dir[0];
        else
            $Directory = $this->Directory . $dir[0];

        if (is_dir($Directory))
        {
            $this->LoadDirectory($Directory);
            $entry = $this->Entry;
            $entry->set_text('');
            $window = $this->janela;
            $window->set_focus($entry);
        }
        else
        {
            $entry = $this->Entry;
            $entry->set_text($dir[0]);
            $window = $this->janela;
            $window->set_focus($entry);
        }
    }

    /***********************************************************/
    /* Loads a directory in the List
    /***********************************************************/
    function LoadDirectory($Directory)
    {
        global $Pixmaps;

		$dir = @opendir($Directory);
        $this->Directory = $Directory;
		if (!$dir)
		{
			return;
		}

        # Put the dirs on ComboBox
        $Directory_ = substr($Directory, strlen($this->root));

        $split = explode($this->barra, $Directory_);
        $dirs = null;
        foreach($split as $part)
        {
            if ($part)
            {
                $join .= $this->barra . $part;
                $dirs[] = $join;
            }
        }
        if ($dirs)
        {
            $combo = $this->Combo;
            $entry = $combo->entry;
            $combo->set_popdown_strings($dirs);
            $entry->set_text($Directory);
        }
        else
        {
            $combo = $this->Combo;
            $combo->set_popdown_strings(array(null));
        }


        GtkCList::Clear();

        # Read the entries
		while (($arquivo = readdir($dir)) !== false)
		{
			$Caminho = $Directory . $this->barra . $arquivo;

			if (is_dir($Caminho))
				$arquivo = ' ' . $arquivo;

			if (substr(trim($arquivo),0,1) != '.')
				$filelist[] = $arquivo;
		}
		if ($filelist)
		{
			sort($filelist);
			foreach ($filelist as $arquivo)
			{
				$arquivo = trim($arquivo);
				$Caminho = $Directory . $this->barra . $arquivo;
				if ($arquivo == '.' || $arquivo == '..')
                {
					continue;
                }

				if (is_dir($Caminho))
				{
                    $ico = $Pixmaps['folder1'];
                    $nodo = GtkCList::append(array($arquivo, $this->FileSize($Caminho), $this->FileDate($Caminho)));
                    GtkCList::set_pixtext($nodo, 0, $arquivo, 2, $ico[0], $ico[1]);
				}
				else
				{
                    if (count($this->Filter) == 1)
                    {
                        $ok = ($this->Filter) ? (in_array(substr($Caminho,-strlen($this->Filter[0])), $this->Filter)) : true;
                    }
                    else
                    {
                        $ok1 = ($this->Filter) ? (in_array(substr($Caminho,-3), $this->Filter)) : true;
                        $ok2 = ($this->Filter) ? (in_array(substr($Caminho,-4), $this->Filter)) : true;
                        $ok = ($ok1 or $ok2);
                    }
                    if ($ok)
                    {
                        $posicao = strpos($arquivo, '.');
                        $ext = substr($arquivo, $posicao+1);
                        $ico = $Pixmaps[$ext];
                        if (!$ico)
                            $ico = $Pixmaps['generic'];
                        $nodo = GtkCList::append(array($arquivo, $this->FileSize($Caminho), $this->FileDate($Caminho)));
                        GtkCList::set_pixtext($nodo, 0, $arquivo, 2, $ico[0], $ico[1]);
                    }
				}
			}
		}
    }

    /***********************************************************/
    /* Returns the FileSize
    /***********************************************************/
    function FileSize($file)
    {
        $sizelb = array('b','kb','Mb','Gb');
        if($size=@filesize($file))
        {
                foreach($sizelb as $lb){
                        if($size<1000){
                                $size = round($size,1)." $lb";
                                break;
                        }
                        $size = $size/1024;
                }
        }
        return $size;
    }

    /***********************************************************/
    /* Returns FileDate
    /***********************************************************/
    function FileDate($file)
    {
        return date("Y-m-d H:i",@fileatime($file));
    }
}
?>