<?
/***********************************************************/
/* Classe que cria Grid de Edio de Tabelas               */
/* Linguagem PHP-GTK                                       */
/* Autor: Pablo Dall'Oglio                                 */
/*Totalmente reformulada por Helder Mauricio Gomes Ferreira*/
/* ltima aterao em 12 abril 2008 por Helder             */
/***********************************************************/

class Grid extends GtkTreeView
{
var $window;
  var $clist;
  var $button;
  var $model;
  function FechaGrid()
  {
    $this->window->hide();
  }
         //recebe de 1161 TulipEditor
         //Grid('abc', $Fields, $Pixmaps['field']);
function __construct($Title, $Titles, $pix)
    {
    
    // chama o metodo construtor da classe pai
    //mesmo que new "GtkTreeView"
    parent::__construct();
    
    $this->selection = parent::get_selection(); // note 1
    $this->selection->connect('changed',array(&$this,'onClick')); // note 2
}

function onClick() {
    $table = $this->properties['Table'];
    if($this->model){
        list($this->model, $iter) = $this->selection->get_selected();
        if($iter)
        {
            $i=0;//zerando o numero do iten
            $Fields=$this->Titles;
            foreach ($Fields as $title)
            { 
            //lendo todos os itens de uma linha 
                $content = $this->model->get_value($iter, $i); 
          
                $ParameterList[] = array($content,  $title,  false, null);
                $i++;
            }
              $this->Record = new FormEntry(Trans::Translate('Record')."->".$table,
                                            $ParameterList, false, Trans::Translate('Edit the record above'));
        
              $botao1 = $this->Record->button1;
              $botao2 = $this->Record->button2;
        
              $botao1->connect_simple('clicked', array(&$this,'ReturnUpdate'));
              $botao2->connect_simple('clicked', array(&$this,'ReturnDelete'));
        
              $record = $this->Record;
              $record->Show();
          }
    }
  }
  
function ReturnUpdate()
  {   echo "\ngrid.class 62 rodando o botao update ";
	  $inputentries = $this->Record->InputEntries;
	  $oldcontents = $this->Record->OldContents;
	  $table = $this->properties['Table'];
	  foreach ($inputentries as $key => $input)
	  {
		  $oldcontent = $oldcontents[$key];
		  if ($input->entry) // gtkcombo
		  {
			  $entry = $input->entry;
			  $content = $entry->get_text();
		  }
		  else // gtkentry
		  {
			  $content = $input->get_text();
		  }
		  if ($content != $oldcontent)
		  {
		    $setfields .= "$key = '$content',";
		  }
		  if ($oldcontent)
		    $wherefields .= "$key = '$oldcontent' and ";
	  }
      echo "\ngrid.class 87 rodando o botao update ";
	  $setfields = substr($setfields,0,-1);
	  $wherefields = substr($wherefields,0,-5);
	  if ($setfields)
	  {
	    $sql = "update $table set $setfields where $wherefields";
	    $this->ConfirmSql($sql);
	  }
  }

function ReturnDelete()
  {
	  $inputentries = $this->Record->InputEntries;
	  $oldcontents = $this->Record->OldContents;
	  $table = $this->properties['Table'];
	  foreach ($inputentries as $key => $input)
	  {
		  $oldcontent = $oldcontents[$key];
		  if ($input->entry) // gtkcombo
		  {
			  $entry = $input->entry;
			  $content = $entry->get_text();
		  }
		  else // gtkentry
		  {
			  $content = $input->get_text();
		  }

		  if ($oldcontent)
		    $wherefields .= "$key = '$oldcontent' and ";
	  }

	  $wherefields = substr($wherefields,0,-5);
      $sql = "delete from $table where $wherefields";
	  $this->ConfirmSql($sql);
  } 
function KeyTest($p1)
  {
    if ($p1->keyval == K_ESC)
    {
        //$this->button->clicked();
        $win = $this->confirm;
        $win->hide();
    }
  }  
function ConfirmSql($sql)
  {   echo "\n grid.class 123 confirmSql";
	  $blue = new GdkColor(0, 0, 65535);
	  //$font = gdk::font_load ("-*-courier-medium-r-normal-*-*-160-*-*-*-*-*-*");
																							 
	  $this->confirm = $janela = new GtkWindow;
      $janela->connect('key_press_event', array(&$this, 'KeyTest'));
	  $janela->set_position(GTK_WIN_POS_CENTER);
	  $janela->set_default_size(600,200);

	 //$this->texto = $texto = new GtkText;
     // ========
      // Create a new buffer and a new view to show the buffer.
      $this->texto = $buffer = new GtkTextBuffer();
      $view = new GtkTextView();
      $view->set_buffer($buffer);
      $view->modify_font(new PangoFontDescription("Arial 12"));
      $view->set_wrap_mode(Gtk::WRAP_WORD);
      //limpando o bufer
      $first = $this->texto->get_start_iter();
      $end   = $this->texto->get_end_iter();
      $this->texto->delete($first,$end);
      $this->texto->insert_at_cursor($sql);
      
	  $botao = new Icone( images . 'ico_ok.xpm', ' Ok ', ' Ok ',  true);
	  $botao->connect_simple('clicked', array(&$this, 'ExecuteSql'));

	  $hbox = new GtkHBox;
	  $hbox->pack_start(new GtkHBox, true, true);
	  $hbox->pack_start($botao, false, false);
	  $hbox->pack_start(new GtkHBox, true, true);

	  $vbox = new GtkVBox;
	  $vbox->pack_start($view, true, true);
	  $vbox->pack_start($hbox, false, false);
	  $janela->add($vbox);
	  $janela->show_all();
  }

  function ExecuteSql()
  {
	  $texto = $this->texto;
      //recuperando os dados do bufer
      $first = $this->texto->get_start_iter();
      $end   = $this->texto->get_end_iter();
      $sqlnew= $this->texto->get_text($first,$end);
      //comprimento em caracteres
      $lenght = $this->texto->get_char_count();//get_length();
      //caracteres
	  $chars = $sqlnew   ;//$this->texto->get_chars(0, $lenght);

	  $conn   = new AgataConnection;
	  $Pass   = $conn->Open($this->properties);
	  if ($Pass)
	  {
		  $conn->CreateQuery($chars);
		  $confirm = $this->confirm;
		  $confirm->hide();
	  }
	  $conn->Close();
	  return false;
  }
function meuSetSearch($coluna, $treeview){
    // quando clica na coluna ele seta para buscar por ela
    $id=$coluna->get_sort_column_id();
    parent::set_search_column($id);
}
function clear(){
    $this->model->clear();// Remove todos os dados (linhas), a partir da lista, deixando vazio.
    $this->model=null;
    parent::set_model($this->model);
    //excluindo na raa as colunas anteriores se houver
    $i=0;
    echo "\n iniciando a exclusao das colunas";
    while($column=$this->get_column(0) )
    {        
        //$column=$this->get_column(0);
        $this->remove_column($column);
        $i++;
        echo "\n removido a coluna $i";
        }
    echo "\n exclusao de colunas terminada";
    $this->model = null;
    $this->set_model($this->model);//esvasiando o modelo
    }
function new_model(){
    $this->set_model($this->model);
    }

function  monta_model($Fields){
    
    $tmp='';
    $tmp=str_repeat('Gtk::TYPE_STRING,',count($Fields));
    $tmp=substr($tmp,0,-1);        
    eval('$this->model=new GtkListStore('.$tmp.');');
    $this->Titles = $Fields;
    }
    // reformata toda as colunas e coloca os nomes 
function add_coluna_treeview($campos,$treeview,$model,$size=null,$cor=null,$fonte=null,$tabela=null,$funcaocor=null) {
    // adiciona uma coluna simples de modo texto numa GtkTreeView
    // parametros:
    //    $campos: um array com os nomes das colunas
    //    $treeview: a variavel que contem o GtkTreeView
    //	  $size : array com os tamanhos das colunas
    //	  $cor: GdkColor 
    //	  $fonte: string com a fonte a ser usada nas linhas. Exemplo: "courier bold 12"
    
    
        
        
    $cell_renderer = new GtkCellRendererText();
    if($cor){
        $cell_renderer->set_property("foreground-gdk",$cor);        		
    }
    if($fonte){
        $cell_renderer->set_property('font', $fonte);
    }
    //for($i=0;$i<count($campos);$i++){
    
    $i=0;
    foreach ($campos as $camp){
        if(!empty($camp)){
            //Create the first column, make it resizable and sortable
            $col[$i] = new GtkTreeViewColumn($camp, $cell_renderer, 'text', $i);
            $col[$i]->connect('clicked',array($this,'meuSetSearch'),$model);
            //make the column resizable in width
            $col[$i]->set_resizable(true);
            //make it sortable and let it sort after model column 1
            $col[$i]->set_sort_column_id($i);
            // tamanho da coluna
            if($size[$i]>0 and $size<999){
                $col[$i]->set_min_width($size[$i]);
                $col[$i]->set_max_width($size[$i]);
            }
            if($size[$i]=="0"){
                $col[$i]->set_visible(false);
                $col[$i]->set_max_width(0);
            }
            
            if($funcaocor){
                $col[$i]->set_cell_data_func($cell_renderer, array($this,$funcaocor));
            }
            //add the column to the view
            
            $treeview->append_column($col[$i]);
        }
        $i++;
    }
    return $col;
}

function AppendLineItems($Contents,$model){
    //percorre as pastas
   // $modele=$model;
   //echo "/nGrid.class 145 colocando linhas $Contents ..\n";
   // print_r($Contents);
    foreach ($Contents as $content)
    { 
        $iter = $model->append();
        //$content array com todas as colunas
        $i=0;//zerando o numero da coluna
        foreach ($content as $registro)
        {
        //adiciona a linha na arvore contendo pasta
        $model->set($iter, $i,$registro );
        $i++;
        }
    }
    
    }

}
?>